local transtonum = {
	[FF_TRANS90] = 9,
	[FF_TRANS80] = 8,
	[FF_TRANS70] = 7,
	[FF_TRANS60] = 6,
	[FF_TRANS50] = 5,
	[FF_TRANS40] = 4,
	[FF_TRANS30] = 3,
	[FF_TRANS20] = 2,
	[FF_TRANS10] = 1,
	[0] = 0
}
local numtotrans = {
	[9] = FF_TRANS90,
	[8] = FF_TRANS80,
	[7] = FF_TRANS70,
	[6] = FF_TRANS60,
	[5] = FF_TRANS50,
	[4] = FF_TRANS40,
	[3] = FF_TRANS30,
	[2] = FF_TRANS20,
	[1] = FF_TRANS10,
	[0] = 0,
}
local SPARK_NEWCOLORS = {
/*0.5*/	[SKINCOLOR_TAN] = SKINCOLOR_PASTEL, --SKINCOLOR_NOBLE,
/*1*/	[SKINCOLOR_GOLD] = SKINCOLOR_SAPPHIRE,
/*1.5*/	[SKINCOLOR_KETCHUP] = SKINCOLOR_RASPBERRY, --SKINCOLOR_SALMON,
/*2*/	[SKINCOLOR_TANGERINE] = SKINCOLOR_RUBY,
/*3*/	[SKINCOLOR_BLUE] = SKINCOLOR_FUCHSIA, --SKINCOLOR_GALAXY,
}

local TR = TICRATE

local SKINS = {
	["takisthefox"] = true,
	["soapthehedge"] = true,
}

local cv_lqafterimage = CV_RegisterVar({
	name = "takis_laggyafterimage",
	defaultvalue = "false",
	flags = CV_SHOWMODIF,
	PossibleValue = CV_TrueFalse
})

freeslot("SKINCOLOR_TOPAZ")
freeslot("SKINCOLOR_MOONSTONE")
skincolors[SKINCOLOR_TOPAZ] = {
	name = "Topaz",
	ramp = {0,81,83,73,74,74,65,52,53,54,56,58,60,42,43,45},
	invcolor = SKINCOLOR_MOONSTONE,
    invshade = 10,
    chatcolor = V_YELLOWMAP,
    accessible = true
}
skincolors[SKINCOLOR_MOONSTONE] = {
	name = "Moonstone",
	ramp = {0,4,8,9,11,12,14,15,171,172,173,174,175,27,29,31},
	invcolor = SKINCOLOR_TOPAZ,
    invshade = 15,
    chatcolor = V_GRAYMAP,
    accessible = true
}
freeslot("SKINCOLOR_SIBERITE")
skincolors[SKINCOLOR_SIBERITE] = {
	name = "Siberite",
	ramp = {252,177,179,180,181,181,182,182,183,164,166,167,167,168,169,159},
	invcolor = SKINCOLOR_EMERALD,
    invshade = 8,
    chatcolor = V_MAGENTAMAP,
    accessible = true
}
freeslot("SKINCOLOR_SKY")
freeslot("SKINCOLOR_SANDY")
skincolors[SKINCOLOR_SKY] = {
	name = "Sky",
	ramp = {128,128,129,130,131,131,132,133,133,134,135,136,137,137,138,139},
	invcolor = SKINCOLOR_SANDY,
    invshade = 1,
    chatcolor = V_SKYMAP,
    accessible = true
}
skincolors[SKINCOLOR_SANDY] = {
	name = "Sandy",
	ramp = {83,64,65,66,67,230,233,233,234,236,236,198,198,199,199,254},
	invcolor = SKINCOLOR_SKY,
    invshade = 8,
    chatcolor = V_YELLOWMAP,
    accessible = true
}
freeslot("SKINCOLOR_FLAME")
skincolors[SKINCOLOR_FLAME] = {
	name = "Flame",
	ramp = {49,50,51,54,34,34,37,37,37,205,207,207,197,197,199,199},
	invcolor = SKINCOLOR_PURPLE,
    invshade = 8,
    chatcolor = V_REDMAP,
    accessible = true
}

freeslot("SKINCOLOR_TAKIS_REALLYRED")
freeslot("SKINCOLOR_TAKIS_REALLYGREEN")
skincolors[SKINCOLOR_TAKIS_REALLYRED] = {
    name = "Really Red",
    ramp = {35,35,35,35,35,35,35,35,35,35,35,41,41,41,41,41},
    invcolor = SKINCOLOR_TAKIS_REALLYGREEN,
    invshade = 9,
    chatcolor = V_REDMAP,
    accessible = true
}
skincolors[SKINCOLOR_TAKIS_REALLYGREEN] = {
    name = "Really Green",
    ramp = {100,100,100,100,100,100,100,100,100,100,100,191,191,191,191,191},
    invcolor = SKINCOLOR_TAKIS_REALLYRED,
    invshade = 35,
    chatcolor = V_GREENMAP,
    accessible = true
}

/*(
M_MoveColorAfter(SKINCOLOR_TOPAZ,SKINCOLOR_TANGERINE)
M_MoveColorAfter(SKINCOLOR_SANDY,SKINCOLOR_GOLD)
M_MoveColorAfter(SKINCOLOR_MOONSTONE,SKINCOLOR_SLATE)
M_MoveColorAfter(SKINCOLOR_SIBERITE,SKINCOLOR_FUCHSIA)
M_MoveColorAfter(SKINCOLOR_SKY,SKINCOLOR_AQUAMARINE)
*/

freeslot("SPR2_FASS")
spr2defaults[SPR2_FASS] = SPR2_DEAD

freeslot("sfx_sptclt")
local cbcap = "Clutch Boost"
freeslot("sfx_cltch2")
sfxinfo[sfx_cltch2].caption = cbcap
freeslot("sfx_cltch3")
sfxinfo[sfx_cltch3].caption = cbcap
sfxinfo[sfx_cltch3].flags = SF_X2AWAYSOUND|SF_TOTALLYSINGLE
freeslot("sfx_cltch4")
sfxinfo[sfx_cltch4].caption = cbcap

--driftspark
freeslot("SPR_TSPK")

freeslot("MT_TAKIS_AFTERIMAGE")
freeslot("S_TAKIS_AFTERIMAGE")
states[S_TAKIS_AFTERIMAGE] = {
	sprite = SPR_PLAY,
	frame = A,
	tics = -1,
	nextstate = S_TAKIS_AFTERIMAGE
}
mobjinfo[MT_TAKIS_AFTERIMAGE] = {
	doomednum = -1,
	spawnstate = S_TAKIS_AFTERIMAGE,
	radius = 12*FRACUNIT,
	height = 10*FRACUNIT,
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_NOBLOCKMAP	
}

freeslot("SPR_TGIB")
freeslot("S_TAKIS_GIB")
freeslot("MT_TAKIS_GIB")
states[S_TAKIS_GIB] = {
	sprite = SPR_TGIB,
	frame = A,
	tics = -1,
}
mobjinfo[MT_TAKIS_GIB] = {
	doomednum = -1,
	spawnstate = S_TAKIS_GIB,
	flags = MF_SLIDEME|MF_NOCLIPTHING|MF_NOSQUISH,
	height = 4*FRACUNIT,
	radius = 4*FRACUNIT,
}

freeslot("SPR_CDST")
freeslot("S_TAKIS_CLUTCHDUST")
freeslot("MT_TAKIS_CLUTCHDUST")
states[S_TAKIS_CLUTCHDUST] = {
	sprite = SPR_CDST,
	frame = A|FF_PAPERSPRITE|FF_ANIMATE|FF_FULLBRIGHT,
	var1 = 6,
	var2 = 2,
	tics = 6*2,
}
mobjinfo[MT_TAKIS_CLUTCHDUST] = {
	doomednum = -1,
	spawnstate = S_TAKIS_CLUTCHDUST,
	flags = MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_NOGRAVITY|MF_NOSQUISH,
	height = 5*FRACUNIT,
	radius = 5*FRACUNIT,
}

rawset(_G, 'L_ZLaunch', function(mo,thrust,relative)
	if mo.eflags&MFE_UNDERWATER
		thrust = $*3/5
	end
	P_SetObjectMomZ(mo,thrust,relative)
end)

local function choosething(...)
	local args = {...}
	local choice = P_RandomRange(1,#args)
	return args[choice]
end

rawset(_G, "TakisCreateAfterimage", function(p,me)
	if not me
	or not me.valid
		return
	end
	
	local takis = p.takistable
	
	local ghost = P_SpawnMobjFromMobj(me,0,0,0,MT_TAKIS_AFTERIMAGE)
	ghost.target = me
	
	ghost.skin = me.skin
	ghost.scale = me.scale
	
	ghost.sprite = me.sprite
	
	ghost.state = me.state
	ghost.sprite2 = me.sprite2
	ghost.takis_frame = me.frame
	ghost.tics = -1
	ghost.colorized = true
	
	ghost.angle = p.drawangle
	
	local color = SKINCOLOR_GREEN
	if me.skin == "takisthefox"
		--not everyone is salmon
		local salnum = #skincolors[ColorOpposite(p.skincolor)]
		takis.afterimagecolor = $+1
		if (takis.afterimagecolor > #skincolors-1-salnum)
			takis.afterimagecolor = 1
		end
		color = salnum+takis.afterimagecolor
		
		--STILL over the max colors??
		if color > #skincolors-1
			--whatever....
			salnum = #skincolors[ColorOpposite(SKINCOLOR_PINETREE)]
			color = salnum+takis.afterimagecolor
		end
		if p.invincibilitytimer
			local pw_inv = p.invincibilitytimer
			local defaultTime = (8*TICRATE)+(2*TICRATE)
			local flicker = 2
			
			if pw_inv > defaultTime
				color = me.color
			else
				flicker = $+(defaultTime-pw_inv)/TICRATE/2
			end
			
			if not (leveltime % flicker == 0)
				color = salnum+takis.afterimagecolor
			end
		end
		if cv_lqafterimage.value
		and CV_FindVar("renderer").value == 2
			color = salnum
		end
		
		--theres blendmodes but THEYRE BARELY VISIBLE so whats the point
		ghost.renderflags = $|RF_ADD
		ghost.destscale = 1
		ghost.scalespeed = FixedDiv(ghost.scale, 16*FU)
	else
		color = choosething(SKINCOLOR_TAKIS_REALLYRED,SKINCOLOR_TAKIS_REALLYGREEN)
	end
	ghost.frame = $|FF_FULLBRIGHT &~FF_TRANSMASK
	
	ghost.color = color
	ghost.takis_spritexscale,ghost.takis_spriteyscale = me.spritexscale, me.spriteyscale
	ghost.takis_spritexoffset,ghost.takis_spriteyoffset = me.spritexoffset, me.spriteyoffset
	ghost.takis_rollangle = me.rollangle
	ghost.takis_pitch = me.pitch
	ghost.takis_roll = me.roll
	ghost.takis_underwater = 0 --me.eflags & MFE_UNDERWATER
	--ghost.takis_watertilt = p.underwatertilt
	ghost.takis_sliptide = p.aizdrifttilt
	ghost.takis_stairjank = p.stairjank
	if AngleFixed(p.aizdrifttilt) > 180*FU
		ghost.takis_sliptide = InvAngle(p.aizdrifttilt)
	end
	--theres some weird interp lag with the pitch/roll
	ghost.pitch,ghost.roll = me.pitch,me.roll
	P_SetOrigin(ghost,ghost.x,ghost.y,ghost.z)
	
	--youre welcome :))))))
	--set dontdraw too so we dont draw on top of our guy
	ghost.renderflags = $|RF_REDUCEVFX|RF_DONTDRAW
	
	--lets also set this here
	if me.hitlag
	and P_RandomChance(FU/2)
		ghost.colorized = false
		ghost.renderflags = $ &~(RF_ADD|RF_DONTDRAW)
		
		K_AddHitLag(ghost,me.hitlag,true)
		ghost.hitlag = me.hitlag
	end
	
	return ghost
end)

rawset(_G,"MetalOrRegularGibs",function(mo)
	local spawnmetal = true
	
	if ((mo.flags & MF_ENEMY|MF_BOSS)
	or (mo.type == MT_TAKIS_BADNIK_RAGDOLL))
		if mo.takis_metalgibs ~= nil
			spawnmetal = mo.takis_metalgibs
		end
	end
	
	if (mo.type == MT_PLAYER or mo.sprite == SPR_PLAY)
		if not (
			(mo.player and (mo.player.charflags & SF_MACHINE))
			or
			(skins[mo.skin].flags & SF_MACHINE)
		)
			spawnmetal = false
		else
			spawnmetal = true
		end
	end
	
	return spawnmetal
end)

rawset(_G,"SpawnEnemyGibs",function(t,tm,ang)
	local count = P_RandomRange(9,19)
	
	local mo = tm or t
	for i = 0,count
		
		local fa = FixedAngle(i*FixedDiv(360*FU,count*FU))
		local radius = 15*mo.scale
		local v = {}
		v[0] = FixedMul(cos(fa),radius)
		v[1] = FixedMul(sin(fa),radius)
		v[2] = 0
		v[3] = FU
		
		local final = {
			x = mo.x+v[0],
			y = mo.y+v[1],
			z = mo.z+v[2]+(mo.height/2),
		}
		local x,y,z = final.x,final.y,final.z
	
		local gib = P_SpawnMobj(x,y,z,MT_TAKIS_GIB)
		gib.scale = mo.scale
		gib.iwillbouncetwice = P_RandomChance(FU/2)
		
		gib.frame = P_RandomRange(A,I)
		if (mo and mo.valid)
			if not fromdoor
				if not MetalOrRegularGibs(mo)
					gib.frame = choosething(A,B,E,G,H,I)
				end
			else
				gib.frame = A
				gib.sprite = states[S_WOODDEBRIS].sprite
				gib.radius = 10*gib.scale
				gib.height = 10*gib.scale
			end
		end
		gib.flags2 = $|(mo.flags2 & MF2_OBJECTFLIP)
		
		local angrng = P_RandomRange(0,1)
		gib.angle = fa
		gib.rollangle = FixedAngle(P_RandomRange(0,359)*FU+P_RandomFixed())
		gib.angleroll = FixedAngle(P_RandomRange(1,15)*FU+P_RandomFixed())*(angrng or -1)
		gib.fuse = 3*TR
		L_ZLaunch(gib,P_RandomRange(4,15)*FU+P_RandomFixed())
		--youre welcome :))))))
		gib.renderflags = $|RF_REDUCEVFX
		
		local momx = FixedMul(mo.momx,P_RandomFixed())
		local momy = FixedMul(mo.momy,P_RandomFixed())
		local momz = FixedMul(mo.momz,P_RandomFixed())
		
		gib.momx,gib.momy,gib.momz = $1+momx,$2+momy,$3+momz
		if (mo.hitlag)
			K_AddHitLag(gib,mo.hitlag,true)
		end
		
		/*
		if (t and t.valid)
			P_Thrust(gib,
				R_PointToAngle2(t.x,t.y, tm.x,tm.y),
				speed/6
			)
		end
		*/
		P_Thrust(gib,gib.angle,P_RandomRange(1,10)*gib.scale+P_RandomFixed())
	end
end)

--UNEXPOSED YES YAY!!!!!
rawset(_G,"P_GetMobjZMovement",function(mo)
	local slope = mo.standingslope
	local angDiff
	local speed

	if not (P_IsObjectOnGround(mo))
		return mo.momz
	end
	
	if not (slope)
		return 0
	end
	
	angDiff = R_PointToAngle2(0, 0, mo.momx, mo.momy) - slope.xydirection
	speed = FixedHypot(mo.momx, mo.momy)

	return P_ReturnThrustY(mo, slope.zangle, P_ReturnThrustX(mo, angDiff, speed))
end)

local function getmaxspeed()
	--gear 1
	if gamespeed == 0
		return 45*FU
	--gear 2
	elseif gamespeed == 1
		return 50*FU
	--gear 3
	elseif gamespeed == 2
		return 60*FU
	--no 4th gear
	end
end

addHook("PlayerThink",function(p)
	local me = p.mo
	if not (me and me.valid) then return end
	
	if p.takistable == nil
		p.takistable = {
			afterimagecolor = 1,
			last_spark = 0,
			last_drift = 0,
			accspeed = 0,
			gibtime = 0,
			c3 = 0,
		}
	end
	local takis = p.takistable
	takis.accspeed = FixedDiv(abs(FixedHypot(p.rmomx,p.rmomy)), me.scale)
	
	if takis.gibtime
		SpawnEnemyGibs(me,me)
		takis.gibtime = $-1
		
		if (SKINS[me.skin] == true)
		and (takis.gibtime == 5)
		and not me.health
			--always use takis' sound
			S_StartSound(me, skins["takisthefox"].soundsid[SKSKLOSE])
			S_StartSound(me, skins["takisthefox"].soundsid[SKSKLOSE])
		end
	end
	
	if (p.cmd.buttons & BT_LUAC)
		takis.c3 = $+1
	else
		takis.c3 = 0
	end
	
	if (SKINS[me.skin] == true)
		
		if takis.c3 == TR
			CV_StealthSet(cv_lqafterimage, 1 - cv_lqafterimage.value)
			CONS_Printf(p,"\x82Turned "..(not cv_lqafterimage.value and "off" or "on").." low-quality afterimages. (Held lua C button for 1 second)")
		end
		
		if p.deadtimer == 2
			me.takis_specialdeath = P_RandomChance(FU/2)
		end
		if me.takis_specialdeath
			if me.sprite2 == SPR2_DEAD
				me.sprite2 = SPR2_FASS
			end
		end
		
		if takis.accspeed >= 45*FU
		or (p.exiting)
		or (p.invincibilitytimer)
		or (p.handleboost >= ((7*FU/8)/2))
			TakisCreateAfterimage(p,me)
		else
			takis.afterimagecolor = 1
		end
		
		if takis.last_spark > p.driftcharge
		and takis.last_spark >= K_GetKartDriftSparkValue(p)
		and abs(takis.last_drift) >= 4
		and ((takis.last_drift ~= p.drift) or (p.pflags & PF_DRIFTEND))
		--only when you actually miniturbo
		and p.driftboost
			if not CV_FindVar("reducevfx").value
				S_StartSoundAtVolume(me,sfx_cltch2,255*4/5,p)
				S_StartSoundAtVolume(me,sfx_cltch3,170,p)
				S_StartSoundAtVolume(me,sfx_cltch4,230)
			end
			
			local d1,d2
			do
				local ang = me.angle
				d1 = P_SpawnMobjFromMobj(me, -20*cos(ang + ANGLE_45), -20*sin(ang + ANGLE_45), 0, MT_TAKIS_CLUTCHDUST)
				d2 = P_SpawnMobjFromMobj(me, -20*cos(ang - ANGLE_45), -20*sin(ang - ANGLE_45), 0, MT_TAKIS_CLUTCHDUST)
				d1.angle = R_PointToAngle2(me.x, me.y, d1.x, d1.y) --- ANG5
				d2.angle = R_PointToAngle2(me.x, me.y, d2.x, d2.y) --+ ANG5
				
				d1.momx,d1.momy = me.momx,me.momy
				d2.momx,d2.momy = me.momx,me.momy
				d1.momz = P_GetMobjZMovement(me)
				d2.momz = P_GetMobjZMovement(me)
				
				d1.renderflags = $|RF_REDUCEVFX
				d2.renderflags = $|RF_REDUCEVFX
			end
		end
	end
	
	takis.last_spark = p.driftcharge
	takis.last_drift = p.drift
	
end)

local brakedrifts = {}
addHook("PostThinkFrame",do for p in players.iterate
	local me = p.mo
	if not (me and me.valid) then continue end
	local takis = p.takistable
	if not takis then continue end
	
	if SKINS[me.skin] ~= true then continue end
	if me.health then continue end
	
	if me.takis_specialdeath
		if me.sprite2 == SPR2_DEAD
			me.sprite2 = SPR2_FASS
		elseif me.sprite2 == SPR2_FASS
			me.frame = ($ &~FF_FRAMEMASK)|((leveltime/2) & 1)
		end
	end
end; for k,mo in ipairs(brakedrifts)
	if not (mo and mo.valid)
		table.remove(brakedrifts,k)
		continue
	end

	if not mo.takis then continue end
	
	if SPARK_NEWCOLORS[mo.color] ~= nil
		mo.color = SPARK_NEWCOLORS[mo.color]
	end
	
	--see p_mobj.c:7631
	if mo.type == MT_DRIFTEXPLODE
	and mo.color == SKINCOLOR_SAPPHIRE
	and mo.fuse <= 48
		mo.color = SPARK_NEWCOLORS[SKINCOLOR_BLUE]
	end
	if mo.type == MT_DRIFTSPARK
		if mo.sprite ~= SPR_TSPK
			mo.sprite = SPR_TSPK
		end
	end
end; end)
addHook("NetVars",function(n) brakedrifts = n($); end)

addHook("PlayerSpawn",function(p)
	--lol
	if (p.takistable)
		p.takistable.gibtime = 0
	end
end)

addHook("MobjThinker", function(ai)
	if not (ai and ai.valid)
		return
	end
	
	--we need a thing to follow
	if not (ai.target and ai.target.valid)
		P_RemoveMobj(ai)
		return
	end
	
	local p = ai.target.player
	local me = p.mo
	
	ai.colorized = true
	if (me.skin == "takisthefox")
		ai.renderflags = $|RF_ADD
		/*
		if not cv_lqafterimage.value
			ai.renderflags = $|RF_ADD
		else
			ai.renderflags = $ &~RF_ADD
		end
		*/
		ai.frame = $|TR_TRANS10
	end
	
	if me.hitlag
		--FINALLY somethings exposed!!!!!!
		ai.colorized = false
		ai.renderflags = $ &~RF_ADD
		
		K_AddHitLag(ai,me.hitlag,true)
		ai.hitlag = me.hitlag
		
		return true
		
		--ai.eflags = $|(me.eflags & MFE_DAMAGEHITLAG)
		--ai.hitlag = me.hitlag
	end
	
	if not ai.timealive
		ai.timealive = 1	
	else
		ai.timealive = $+1
		ai.renderflags = $ &~RF_DONTDRAW
	end
	
	ai.spritexoffset = ai.takis_spritexoffset or 0
	ai.spriteyoffset = ai.takis_spriteyoffset or 0
	ai.spritexscale = ai.takis_spritexscale or FU
	ai.spriteyscale = ai.takis_spriteyscale or FU
	--ai.rollangle = ai.takis_rollangle or 0
	ai.pitch = ai.takis_pitch or 0
	ai.roll = ai.takis_roll or 0
	
	local viewang = R_PointToAngle(me.x,me.y)
	local angdelta = viewang - ai.angle
	
	local rolladd = 0
	if ai.takis_sliptide
		rolladd = $+
			FixedMul(ai.takis_sliptide,sin(abs(angdelta)))+
			FixedMul(ai.takis_sliptide,cos(angdelta))
	end
	ai.rollangle = rolladd + (ai.takis_rollangle or 0)
	
	local fuselimit = 3
	if ai.skin == "takisthefox"
		fuselimit = 5
		local transnum = numtotrans[((ai.timealive*2/3)+1) %9]
		ai.frame = ai.takis_frame|transnum
	else
		if (leveltime % 6) > 2
			ai.renderflags = $|RF_DONTDRAW
		else
			ai.renderflags = $ &~RF_DONTDRAW
		end
	end
	
	--because fuse doesnt wanna work
	if ai.timealive > fuselimit
		P_RemoveMobj(ai)
		return
	end
	
end, MT_TAKIS_AFTERIMAGE)

addHook("MobjThinker",function(gib)
	if not (gib and gib.valid) then return end
	local grav = P_GetMobjGravity(gib)
	grav = $*3/5
	gib.spritexscale,gib.spriteyscale = FU,FU
	gib.momz = $+(grav*P_MobjFlip(gib))
	gib.rollangle = $+(gib.angleroll or 0)
	gib.speed = FixedHypot(gib.momx,gib.momy)
	gib.bouncecount = $ or 0
	if (P_IsObjectOnGround(gib)
	and not gib.bounced)
		gib.momz = -FixedMul((gib.lastmomz ~= nil and gib.lastmomz or gib.momz), FU*89/100)
		
		if not gib.iwillbouncetwice
			gib.flags = $|MF_NOCLIPHEIGHT|MF_NOCLIP
		else
			gib.iwillbouncetwice = nil
		end
		gib.tics = 6*TR
		
		gib.bouncecount = $ + 1
		gib.hitlag = P_RandomRange(1,5)
		gib.spritexscale = 2*FU
		gib.spriteyscale = FU/2
	end
	
	if gib.lastmomz ~= nil
	and abs(gib.lastmomz) < 3*gib.scale
	and (gib.bouncecount >= 2)
		gib.bounced = true
	end
	gib.lastmomz = gib.momz
end,MT_TAKIS_GIB)

addHook("MobjMoveBlocked",function(gib)
	if gib.flags & MF_NOCLIP then return end
	if gib.bounced then return end
	
	--P_BounceMove(gib)
	local speed = R_PointToDist2(0,0,gib.momx, gib.momy)
	gib.angle = FixedAngle(AngleFixed($)+180*FU)
	
	gib.momx = P_ReturnThrustX(nil,gib.angle, speed)
	gib.momy = P_ReturnThrustY(nil,gib.angle, speed)
end,MT_TAKIS_GIB)

--only takis gets these gibs, no (SKINS[me.skin] ~= true) check
local function hitbytakis(mo,inf,sor)
	if not ((mo.skin == "takisthefox")
	or ((sor and sor.valid) and sor.skin == "takisthefox"))
		return
	end
	
	mo.player.takistable.gibtime = 7
	
	if mo.hitlag
		SpawnEnemyGibs(mo,inf or mo)
	end
end
addHook("MobjDamage",hitbytakis,MT_PLAYER)
addHook("MobjDeath",hitbytakis,MT_PLAYER)

freeslot(
	"SPR_TDDE",
	"SPR_TDDA",
	"SPR_TDDC",
	"SPR_TDDG",
	"SPR_TDDB",
	"SPR_TDDI",
	"SPR_TDDJ",
	"SPR_TDDK",
	"SPR_TDDH",
	"SPR_TDDF"
)
addHook("MobjThinker",function(car)
	if not (car and car.valid) then return end
	
	local tar = car.target
	if not (tar and tar.valid) then return end
	
	if SKINS[tar.skin] == true
		car.sprite = SPR_TDDF
		if tar.skin == "soapthehedge"
			car.frame = B
			car.flags = $|MF_NOSQUISH
			car.spritexscale,car.spriteyscale = FU/4,FU/4
		end
	end
end,MT_KART_LEFTOVER)

local spritetotakis = {
	[SPR_DIEE] = SPR_TDDE,	--wheel
	[SPR_DIEA] = SPR_TDDA,	--tire
	[SPR_DIEC] = SPR_TDDC,	--pedal bar
	[SPR_DIEG] = SPR_TDDG,	--pedal joint L
	[SPR_DIED] = SPR_TDDG,	--pedal joint R
	[SPR_DIEB] = SPR_TDDB,	--pipeframe
	[SPR_DIEI] = SPR_TDDI,	--various
	[SPR_DIEJ] = SPR_TDDJ,	--various
	[SPR_DIEK] = SPR_TDDK,	--various
	[SPR_DIEH] = SPR_TDDH,	--various
}

local function findTarget(spark,deadonly,distance)
	for p in players.iterate
		if p.spectator then continue end
		if not (p.mo and p.mo.valid) then continue end
		if deadonly
			if p.mo.health then continue end
		elseif not p.mo.health
			continue
		end
		if SKINS[p.mo.skin] ~= true then continue end
		
		local maxdist = distance or 25*FU
		local hdist = R_PointToDist2(spark.x,spark.y,p.mo.x,p.mo.y)
		local dist = R_PointToDist2(0,spark.z,hdist,p.mo.z)
		if dist > FixedMul(maxdist,spark.scale) then continue end
		
		spark.takis = p.mo
		return
	end
end

addHook("MobjThinker",function(car)
	if not (car and car.valid) then return end
	
	if spritetotakis[car.sprite] == nil
		return
	end
	
	--if youve asked me and youre reusing this code,
	--i'd recommend you change "takis_setgibs" to something else,
	--like maybe your skins name, "MyCoolName_setgibs"
	if not car.takis_setgibs
		
		findTarget(car,true)
		if car.takis
			car.sprite = spritetotakis[car.sprite]
			car.takis_setgibs = true
		end
	end
	car.setgibs = true
end,MT_KART_PARTICLE)

local function think(spark)
	if not (spark and spark.valid) then return end
	
	if not spark.set
		findTarget(spark,nil,64*FU)
		if spark.takis
		--adjust these in postthink because rr has an extremely
		--good codebase :)
		and (spark.type == MT_BRAKEDRIFT
		or spark.type == MT_DRIFTEXPLODE
		or spark.type == MT_DRIFTSPARK)
			table.insert(brakedrifts,spark)
		end
		spark.set = true
	end
	
	if not spark.takis then return end
	
	if SPARK_NEWCOLORS[spark.color] ~= nil
		spark.color = SPARK_NEWCOLORS[spark.color]
	end
	
	if spark.type == MT_DRIFTSPARK
		spark.renderflags = $|RF_PAPERSPRITE &~(RF_ADD|RF_TRANSMASK)
		spark.flags = $|MF_NOSQUISH
		
		spark.sprite = SPR_TSPK
		spark.frame = ($ &~(FF_FRAMEMASK|FF_TRANSMASK))|(leveltime % D)
		
		local me = spark.takis
		if (me and me.valid)
			spark.dispoffset = me.dispoffset + 5
			spark.momx = me.momx --* 2
			spark.momy = me.momy --* 2
			spark.momz = P_GetMobjZMovement(me) --* 2
		end
	end
end

--.
addHook("MobjThinker",think,MT_DRIFTSPARK)
addHook("MobjThinker",think,MT_DRIFTELECTRICITY)
addHook("MobjThinker",think,MT_DRIFTDUST)
addHook("MobjThinker",think,MT_BRAKEDRIFT)
addHook("MobjThinker",think,MT_DRIFTEXPLODE)

addHook("MobjSpawn",think,MT_DRIFTSPARK)
addHook("MobjSpawn",think,MT_DRIFTELECTRICITY)
addHook("MobjSpawn",think,MT_DRIFTDUST)
addHook("MobjSpawn",think,MT_BRAKEDRIFT)
addHook("MobjSpawn",think,MT_DRIFTEXPLODE)

/*
COM_AddCommand("suicide", function(p)
	if gamestate ~= GS_LEVEL
		CONS_Printf(p,"You can't use this right now.")
		return
	end
	
	if not (p.mo and p.mo.valid)
	or not (p.mo.health)
	and (false == true)
		CONS_Printf(p,"You can't use this right now.")
		return	
	end
	
	P_KillMobj(p.mo)
end)
*/